<?php

declare(strict_types=1);

namespace CoStack\PhpInterfaces;

/* This file is part of the co-stack/php-interfaces package.
 *
 * (c) Oliver Eglseder <oliver.eglseder@co-stack.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code. */

/**
 * phpcs:disable
 *
 * @see http://php.net/manual/en/class.streamwrapper.php
 *
 * @SuppressWarnings(PHPMD.CamelCaseMethodName)
 * @SuppressWarnings(PHPMD.CamelCaseParameterName)
 */
interface StreamWrapper
{
    /**
     * Close directory handle.
     *
     * @see http://php.net/manual/en/streamwrapper.dir-closedir.php
     *
     * This method is called in response to closedir().
     * Any resources which were locked, or allocated, during opening and use of the directory stream should be released.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function dir_closedir(): bool;

    /**
     * Open directory handle.
     *
     * @see http://php.net/manual/de/streamwrapper.dir-opendir.php
     *
     * This method is called in response to opendir().
     *
     * @param string $path Specifies the URL that was passed to opendir().
     *  Note:
     *      The URL can be broken apart with parse_url().
     * @param int $options Whether or not to enforce safe_mode (0x04).
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function dir_opendir(string $path, int $options): bool;

    /**
     * Read entry from directory handle.
     *
     * @see http://php.net/manual/en/streamwrapper.dir-readdir.php
     *
     * This method is called in response to readdir().
     *
     * @return string|bool Should return string representing the next filename, or FALSE if there is no next file.
     *  Note:
     *      The return value will be casted to string.
     */
    public function dir_readdir();

    /**
     * Rewind directory handle.
     *
     * @see http://php.net/manual/en/streamwrapper.dir-rewinddir.php
     *
     * This method is called in response to rewinddir().
     *
     * Should reset the output generated by streamWrapper::dir_readdir(). i.e.: The next call to
     *     streamWrapper::dir_readdir() should return the first entry in the location returned by
     *     streamWrapper::dir_opendir().
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function dir_rewinddir(): bool;

    /**
     * Create a directory.
     *
     * @see http://php.net/manual/en/streamwrapper.mkdir.php
     *
     * This method is called in response to mkdir().
     *  Note:
     *      In order for the appropriate error message to be returned this method should not be defined if the wrapper
     *     does not support creating directories.
     *
     * @param string $path Directory which should be created.
     * @param int $mode The value passed to mkdir().
     * @param int $options A bitwise mask of values, such as STREAM_MKDIR_RECURSIVE.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function mkdir(string $path, int $mode, int $options): bool;

    /**
     * Renames a file or directory.
     *
     * @see http://php.net/manual/en/streamwrapper.rename.php
     *
     * This method is called in response to rename().
     * Should attempt to rename path_from to path_to
     *  Note:
     *      In order for the appropriate error message to be returned this method should not be defined if the wrapper
     *     does not support renaming files.
     *
     * @param string $path_from The URL to the current file.
     * @param string $path_to The URL which the path_from should be renamed to.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function rename(string $path_from, string $path_to): bool;

    /**
     * Removes a directory.
     *
     * @see http://php.net/manual/en/streamwrapper.rmdir.php
     *
     * This method is called in response to rmdir().
     *  Note:
     *      In order for the appropriate error message to be returned this method should not be defined if the wrapper
     *     does not support removing directories.
     *
     * @param string $path The directory URL which should be removed.
     * @param int $options A bitwise mask of values, such as STREAM_MKDIR_RECURSIVE.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function rmdir(string $path, int $options): bool;

    /**
     * Retrieve the underlaying resource.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-cast.php
     *
     * This method is called in response to stream_select().
     *
     * @param int $cast_as Can be STREAM_CAST_FOR_SELECT when stream_select() is calling stream_cast() or
     *     STREAM_CAST_AS_STREAM when stream_cast() is called for other uses.
     *
     * @return resource|bool Should return the underlying stream resource used by the wrapper, or FALSE.
     */
    public function stream_cast(int $cast_as);

    /**
     * Close a resource.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-close.php
     *
     * This method is called in response to fclose().
     * All resources that were locked, or allocated, by the wrapper should be released.
     */
    public function stream_close(): void;

    /**
     * Tests for end-of-file on a file pointer.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-eof.php
     *
     * This method is called in response to feof().
     *
     * @return bool Should return TRUE if the read/write position is at the end of the stream and if no more data is
     *     available to be read, or FALSE otherwise.
     */
    public function stream_eof(): bool;

    /**
     * Flushes the output.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-flush.php
     *
     * This method is called in response to fflush() and when the stream is being closed while any unflushed data has
     *     been written to it before.
     * If you have cached data in your stream but not yet stored it into the underlying storage, you should do so now.
     *
     * @return bool Should return TRUE if the cached data was successfully stored (or if there was no data to store),
     *     or FALSE if the data could not be stored.
     */
    public function stream_flush(): bool;

    /**
     * Advisory file locking
     *
     * @see http://php.net/manual/en/streamwrapper.stream-lock.php
     *
     * This method is called in response to flock(), when file_put_contents() (when flags contains LOCK_EX),
     *     stream_set_blocking() and when closing the stream (LOCK_UN).
     *
     * @param int $operation operation is one of the following:
     *      LOCK_SH to acquire a shared lock (reader).
     *      LOCK_EX to acquire an exclusive lock (writer).
     *      LOCK_UN to release a lock (shared or exclusive).
     *      LOCK_NB if you don't want flock() to block while locking. (not supported on Windows)
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function stream_lock(int $operation): bool;

    /**
     * Change stream metadata.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-metadata.php
     *
     * This method is called to set metadata on the stream. It is called when one of the following functions is called
     *     on a stream URL:
     *      touch()
     *      chmod()
     *      chown()
     *      chgrp()
     * Please note that some of these operations may not be available on your system.
     *
     * @param string $path The file path or URL to set metadata. Note that in the case of a URL, it must be a ://
     *     delimited URL. Other URL forms are not supported.
     * @param int $option One of:
     *      STREAM_META_TOUCH (The method was called in response to touch())
     *      STREAM_META_OWNER_NAME (The method was called in response to chown() with string parameter)
     *      STREAM_META_OWNER (The method was called in response to chown())
     *      STREAM_META_GROUP_NAME (The method was called in response to chgrp())
     *      STREAM_META_GROUP (The method was called in response to chgrp())
     *      STREAM_META_ACCESS (The method was called in response to chmod())
     * @param mixed $value If option is
     *      STREAM_META_TOUCH: Array consisting of two arguments of the touch() function.
     *      STREAM_META_OWNER_NAME or STREAM_META_GROUP_NAME: The name of the owner user/group as string.
     *      STREAM_META_OWNER or STREAM_META_GROUP: The value owner user/group argument as integer.
     *      STREAM_META_ACCESS: The argument of the chmod() as integer.
     *
     * @return bool Returns TRUE on success or FALSE on failure. If option is not implemented, FALSE should be returned.
     */
    public function stream_metadata(string $path, int $option, $value): bool;

    /**
     * Opens file or URL.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-open.php
     *
     * This method is called immediately after the wrapper is initialized (f.e. by fopen() and file_get_contents()).
     *
     * @param string $path Specifies the URL that was passed to the original function.
     * Note:
     *      The URL can be broken apart with parse_url(). Note that only URLs delimited by :// are supported. : and :/
     *     while technically valid URLs, are not.
     * @param string $mode The mode used to open the file, as detailed for fopen().
     *  Note:
     *      Remember to check if the mode is valid for the path requested.
     * @param int $options Holds additional flags set by the streams API. It can hold one or more of the following
     *     values OR'd together.
     *  <table>
     *      <tr>
     *          <th>Flag</th>
     *          <th>Description</th>
     *      </tr>
     *      <tr>
     *          <td>STREAM_USE_PATH</td>
     *          <td>If path is relative, search for the resource using the include_path.</td>
     *      </tr>
     *      <tr>
     *          <td>STREAM_REPORT_ERRORS</td>
     *          <td>If this flag is set, you are responsible for raising errors using trigger_error() during opening of
     *     the stream. If this flag is not set, you should not raise any errors.</td>
     *      </tr>
     *  </table>
     * @param string|null $opened_path If the path is opened successfully, and STREAM_USE_PATH is set in options,
     *     opened_path should be set to the full path of the file/resource that was actually opened.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     *
     */
    public function stream_open(string $path, string $mode, int $options, string &$opened_path = null): bool;

    /**
     * Read from stream.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-read.php
     *
     * This method is called in response to fread() and fgets().
     *  Note:
     *      Remember to update the read/write position of the stream (by the number of bytes that were successfully
     *     read).
     *
     * @param int $count How many bytes of data from the current position should be returned.
     *
     * @return string If there are less than count bytes available, return as many as are available. If no more data is
     *     available, return either FALSE or an empty string.
     */
    public function stream_read(int $count): string;

    /**
     * Seeks to specific location in a stream
     *
     * @see http://php.net/manual/en/streamwrapper.stream-seek.php
     *
     * This method is called in response to fseek().
     * The read/write position of the stream should be updated according to the offset and whence.
     *
     * @param int $offset The stream offset to seek to.
     * @param int $whence Possible values:
     *      SEEK_SET - Set position equal to offset bytes.
     *      SEEK_CUR - Set position to current location plus offset.
     *      SEEK_END - Set position to end-of-file plus offset.
     *
     * @return bool Return TRUE if the position was updated, FALSE otherwise.
     */
    public function stream_seek(int $offset, int $whence = SEEK_SET): bool;

    /**
     * Change stream options
     *
     * @see http://php.net/manual/en/streamwrapper.stream-set-option.php
     *
     * This method is called to set options on the stream.
     *
     * @param int $option One of:
     *      STREAM_OPTION_BLOCKING (The method was called in response to stream_set_blocking())
     *      STREAM_OPTION_READ_TIMEOUT (The method was called in response to stream_set_timeout())
     *      STREAM_OPTION_WRITE_BUFFER (The method was called in response to stream_set_write_buffer())
     * @param int $arg1 If option is
     *      STREAM_OPTION_BLOCKING: requested blocking mode (1 meaning block 0 not blocking).
     *      STREAM_OPTION_READ_TIMEOUT: the timeout in seconds.
     *      STREAM_OPTION_WRITE_BUFFER: buffer mode (STREAM_BUFFER_NONE or STREAM_BUFFER_FULL).
     * @param int $arg2 If option is
     *      STREAM_OPTION_BLOCKING: This option is not set.
     *      STREAM_OPTION_READ_TIMEOUT: the timeout in microseconds.
     *      STREAM_OPTION_WRITE_BUFFER: the requested buffer size.
     *
     * @return bool Returns TRUE on success or FALSE on failure. If option is not implemented, FALSE should be returned.
     */
    public function stream_set_option(int $option, int $arg1, int $arg2): bool;

    /**
     * Retrieve information about a file resource.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-stat.php
     *
     * This method is called in response to fstat().
     *
     * @return array See stat().
     */
    public function stream_stat(): array;

    /**
     * Retrieve the current position of a stream.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-tell.php
     *
     * This method is called in response to fseek() to determine the current position.
     *
     * @return int Should return the current position of the stream.
     */
    public function stream_tell(): int;

    /**
     * Truncate stream.
     *
     * @see http://php.net/manual/en/streamwrapper.stream-truncate.php
     *
     * Will respond to truncation, e.g., through ftruncate().
     *
     * @param int $new_size The new size.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function stream_truncate(int $new_size): bool;

    /**
     * Write to stream
     *
     * @see http://php.net/manual/en/streamwrapper.stream-write.php
     *
     * This method is called in response to fwrite().
     *  Note:
     *      Remember to update the current position of the stream by number of bytes that were successfully written.
     *
     * @param string $data Should be stored into the underlying stream. Note: If there is not enough room in the
     *     underlying stream, store as much as possible.
     *  Note:
     *      If there is not enough room in the underlying stream, store as much as possible.
     *
     * @return int Should return the number of bytes that were successfully stored, or 0 if none could be stored.
     */
    public function stream_write(string $data): int;

    /**
     * Delete a file.
     *
     * @see http://php.net/manual/en/streamwrapper.unlink.php
     *
     * This method is called in response to unlink().
     *  Note:
     *      In order for the appropriate error message to be returned this method should not be defined if the wrapper
     *     does not support removing files.
     *
     * @param string $path The file URL which should be deleted.
     *
     * @return bool Returns TRUE on success or FALSE on failure.
     */
    public function unlink(string $path): bool;

    /**
     * Retrieve information about a file.
     *
     * @see http://php.net/manual/en/streamwrapper.url-stat.php
     *
     * This method is called in response to all stat() related functions, such as:
     *      chmod() (only when safe_mode is enabled)
     *      copy()
     *      fileperms()
     *      fileinode()
     *      filesize()
     *      fileowner()
     *      filegroup()
     *      fileatime()
     *      filemtime()
     *      filectime()
     *      filetype()
     *      is_writable()
     *      is_readable()
     *      is_executable()
     *      is_file()
     *      is_dir()
     *      is_link()
     *      file_exists()
     *      lstat()
     *      stat()
     *      SplFileInfo::getPerms()
     *      SplFileInfo::getInode()
     *      SplFileInfo::getSize()
     *      SplFileInfo::getOwner()
     *      SplFileInfo::getGroup()
     *      SplFileInfo::getATime()
     *      SplFileInfo::getMTime()
     *      SplFileInfo::getCTime()
     *      SplFileInfo::getType()
     *      SplFileInfo::isWritable()
     *      SplFileInfo::isReadable()
     *      SplFileInfo::isExecutable()
     *      SplFileInfo::isFile()
     *      SplFileInfo::isDir()
     *      SplFileInfo::isLink()
     *      RecursiveDirectoryIterator::hasChildren()
     *
     * @param string $path The file path or URL to stat. Note that in the case of a URL, it must be a :// delimited
     *     URL. Other URL forms are not supported.
     * @param int $flags Holds additional flags set by the streams API. It can hold one or more of the following values
     *     OR'd together.
     *
     *  <table>
     *      <tr>
     *          <th>Flag</th>
     *          <th>Description</th>
     *      </tr>
     *      <tr>
     *          <td>STREAM_URL_STAT_LINK</td>
     *          <td>For resources with the ability to link to other resource (such as an HTTP Location: forward, or a
     *     filesystem symlink). This flag specified that only information about the link itself should be returned, not
     *     the resource pointed to by the link. This flag is set in response to calls to lstat(), is_link(), or
     *     filetype().</td>
     *      </tr>
     *      <tr>
     *          <td>STREAM_URL_STAT_QUIET</td>
     *          <td>If this flag is set, your wrapper should not raise any errors. If this flag is not set, you are
     *     responsible for reporting errors using the trigger_error() function during stating of the path.</td>
     *      </tr>
     *  </table>
     *
     * @return array|false Should return as many elements as stat() does. Unknown or unavailable values should be set
     *     to a rational value (usually 0). Returns FALSE if the file does not exists.
     */
    public function url_stat(string $path, int $flags);
}
